/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;using MeshVR;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;using Battlehub.RTCommon;namespace PluginIdea{    public class HandleCam : MVRScript, IGL    {        public const string InputModule = "InputModule";        public const string GlDrawModule = "GlDrawModule";        public const string PicCapModule = "PicCapModule";        public const string HandModule = "HandModule";        public const string VideoRecordModule = "VideoRecordModule";        public const string CoreModule = "CoreModule";        private Camera fcam, bcam, currentActiveCam;        private Renderer screen;        private Transform pian;        private bool isResourcesLoaded;        private TimerManager timerManager = new TimerManager();        private Dictionary<string, HCModuleBase> uid2Modules = new Dictionary<string, HCModuleBase>();        private Transform camRoot;        public Transform CamRoot        {            get { return this.camRoot; }        }        public Camera ForeCam        {            get { return this.fcam; }        }        public Camera BackCam        {            get { return this.bcam; }        }        public Renderer Screen        {            get { return this.screen; }        }        public TimerManager TimeManager        {            get { return this.timerManager; }        }        public Transform Pian        {            get { return this.pian; }        }        public bool IsResourceLoaded        {            get { return this.isResourcesLoaded; }        }        public CoreModule CModule        {            get { return (uid2Modules[CoreModule] as CoreModule); }        }        private Camera TargetCamera        {            get            {                if (Utils.IsInVR())                {                    if (SuperController.singleton.isOpenVR)                    {                        return SuperController.singleton.ViveCenterCamera;                    }                    return SuperController.singleton.OVRCenterCamera;                }                return SuperController.singleton.MonitorCenterCamera;            }        }        private void Start()        {            if (GLRenderer.Instance == null)            {                new GameObject                {                    name = "GLRenderer"                }.AddComponent<GLRenderer>();            }            GLRenderer.Instance.Add(this);        }        public override void Init()        {            base.Init();            ResourceInit();            UIInit();            EventInit();        }        private void Update()        {            timerManager.Update();            if (uid2Modules.Count > 0)            {                foreach (var module in uid2Modules.Values.ToList())                {                    module.OnUpdate();                }            }        }                private void ResourceInit()        {            string assetsBundlePath = Utils.GetPluginPath(this) + "/resources/hc.assetbundle";            Request request = new Request { path = assetsBundlePath, callback = OnAssetBundleLoaded };            AssetLoader.QueueLoadAssetBundleFromFile(request);        }        private void OnAssetBundleLoaded(Request request)        {            GameObject srcObj = request.assetBundle.LoadAsset<GameObject>("CamRoot");            camRoot = Instantiate<GameObject>(srcObj, containingAtom.reParentObject.Find("object/rescaleObject")).transform;            camRoot.transform.localPosition = Vector3.zero;            camRoot.transform.localRotation = Quaternion.identity;            isResourcesLoaded = true;            DataInit();            ReApplyUIParameter();        }                        private void DataInit()        {            fcam = camRoot.Find("Cams/Fcam").GetComponent<Camera>();            bcam = camRoot.Find("Cams/Bcam").GetComponent<Camera>();            screen = camRoot.Find("Quad").GetComponent<Renderer>();            pian = camRoot.Find("Pian");            fcam.cullingMask = bcam.cullingMask = LayerMask.NameToLayer("Player");            fcam.clearFlags = bcam.clearFlags = TargetCamera.clearFlags;            fcam.backgroundColor = bcam.backgroundColor = TargetCamera.backgroundColor;            camRoot.Find("Triggers/Record").gameObject.SetActive(false);        }        private void UIInit()        {            Utils.OnInitUI(CreateUIElement);        }        private void EventInit()        {            RegisterModule(InputModule, new InputModule(this));            RegisterModule(CoreModule, new CoreModule(this));            RegisterModule(PicCapModule, new PicCapModule(this));                    }                        private void ReApplyUIParameter()        {            if (uid2Modules.Count > 0)            {                foreach (var module in uid2Modules.Values.ToList())                {                    module.OnReApplyUIParameter();                }            }        }        private void RegisterModule(string key, HCModuleBase module)        {            if (!uid2Modules.ContainsKey(key))            {                uid2Modules.Add(key, module);                module.Init();            }        }        private void UnRegisterModule(string key)        {            if (uid2Modules.ContainsKey(key))            {                uid2Modules[key].UnInit();                uid2Modules.Remove(key);            }        }        private void LateUpdate()        {            if (uid2Modules.Count > 0)            {                foreach (var module in uid2Modules.Values.ToList())                {                    module.LateUpdate();                }            }        }        private void OnDestroy()        {            if (uid2Modules.Count > 0)            {                foreach (var key in uid2Modules.Keys.ToList())                {                    UnRegisterModule(key);                }                uid2Modules.Clear();            }            GLRenderer.Instance.Remove(this);            timerManager = null;            Utils.OnDestroyUI();            Destroy(camRoot.gameObject);        }        public void Draw(int cullingMask)        {            if (uid2Modules.Count > 0)            {                foreach (var module in uid2Modules.Values.ToList())                {                    module.OnPostRender();                }            }        }            }}