/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using System.Collections.Generic;namespace PluginIdea{    public class CoreModule : HCModuleBase    {        private List<string> aspectRadioPresets = new List<string> { "Custom", "16:9", "9:16", "16:10", "10:16", "4:3", "3:4", "2:1", "1:2", "1:1" };        private float whAspectValue;        private RenderTexture captureRT;        private Camera currentActiveCam;        private Vector3 startScale;        private JSONStorableStringChooser aspectChooser;        private JSONStorableFloat width, height;        private JSONStorableFloat heightPixelCount;        private SimpleTrigger switchTrigger;        private bool isOnRecord;        public RenderTexture CaptureRT        {            get { return captureRT; }        }        public Camera CurrentAtiveCam        {            get { return currentActiveCam; }         }        public CoreModule(HandleCam ower)        {            this.ower = ower;        }        public override void Init()        {            Utils.SetupInfoTextNoScroll(this.ower, "<size=30><b>Common Parameters</b></size>", 35, false);            width = Utils.SetupSliderFloat(ower, "Width", 0.3f, 0.1f, 1f, false);            height = Utils.SetupSliderFloat(ower, "Height", 0.3f, 0.1f, 1f, false);            heightPixelCount = Utils.SetupSliderInt(ower, "Height Pixel Amount", 1080, 480, 2048, false);            aspectChooser = Utils.SetupStringChooser(ower, "Aspect", aspectRadioPresets, false);            aspectChooser.setCallbackFunction = (val) => {                if (!ower.IsResourceLoaded) return;                switch (val)                {                    case "16:9": whAspectValue = 1.777f; break;                    case "9:16": whAspectValue = 0.5625f; break;                    case "16:10": whAspectValue = 1.6f; break;                    case "10:16": whAspectValue = 0.625f; break;                    case "4:3": whAspectValue = 1.333f; break;                    case "3:4": whAspectValue = 0.75f; break;                    case "2:1": whAspectValue = 2f; break;                    case "1:2": whAspectValue = 0.5f; break;                    case "1:1": whAspectValue = 1f; break;                    default:                        whAspectValue = width.val / height.val;                        break;                }                ChangeRadio(whAspectValue);                RefreshCamRT(isOnRecord);            };                                            }        public void OnCaptureFuncChanged(bool isRecord)        {            isOnRecord = isRecord;            RefreshCamRT(isOnRecord);        }        public override void OnUpdate()        {            base.OnUpdate();            if (Input.GetKeyDown(KeyCode.C)) SwitchCamera();        }        public override void OnReApplyUIParameter()        {            base.OnReApplyUIParameter();            Transform switchBtnTrans = ower.CamRoot.Find("Triggers/SwitchCam");            switchTrigger = Utils.GetSafeComponent<SimpleTrigger>(switchBtnTrans.gameObject);            switchTrigger.onTrigger = SwitchCamera;            startScale = ower.CamRoot.localScale;            ower.ForeCam.gameObject.SetActive(true);            currentActiveCam = ower.ForeCam;                        aspectChooser.setCallbackFunction(aspectChooser.val);        }        private void ChangeRadio(float whRadio)        {            currentActiveCam.aspect = whRadio;            ower.CamRoot.localScale = new Vector3(startScale.x, startScale.x / whRadio, startScale.z);        }        private void RefreshCamRT(bool isRecord = false)        {            RenderTexture.ReleaseTemporary(captureRT);            int w = isRecord ? (int)(480 * whAspectValue) : (int)(heightPixelCount.val * whAspectValue);            int h = isRecord ? 480 : (int)heightPixelCount.val;            SuperController.LogMessage("w: " + w.ToString() + " h: " + h.ToString());            captureRT = RenderTexture.GetTemporary(w, h, 24, RenderTextureFormat.ARGB32);            currentActiveCam.targetTexture = captureRT;            ower.Screen.material.mainTexture = captureRT;        }        private void SwitchCamera()        {            if (ower.ForeCam.gameObject.activeInHierarchy)            {                ower.ForeCam.gameObject.SetActive(false);                ower.BackCam.gameObject.SetActive(true);                currentActiveCam = ower.BackCam;            }            else            {                ower.ForeCam.gameObject.SetActive(true);                ower.BackCam.gameObject.SetActive(false);                currentActiveCam = ower.ForeCam;            }            currentActiveCam.targetTexture = captureRT;        }        public override void UnInit()        {            RenderTexture.ReleaseTemporary(captureRT);        }    }}