/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;using MVR.FileManagementSecure;using System.Linq;using System;namespace PluginIdea{    public class PicCapModule : HCModuleBase    {        private const string SHOT_DIRECTORY = "Saves/CameraShot/";        private SimpleTrigger captureTrigger;        private SimpleTrigger saceTrigger;        private SimpleTrigger cancelTrigger;        private JSONStorableStringChooser layerChooser;        private List<string> layerList = new List<string>();        private Texture2D currentTextureCaptured;        private GameObject saveBtnObj;        private GameObject cancelBtnObj;        private GameObject captureBtnObj;        private AudioSource hcAudioSource;        public PicCapModule(HandleCam ower)        {            this.ower = ower;        }        public override void Init()        {            Utils.SetupSpacer(ower, 30, true);            Utils.SetupInfoTextNoScroll(this.ower, "<size=30><b>Take Shot</b></size>", 35, false);                                                                                                                                }        public override void OnReApplyUIParameter()        {                        captureBtnObj = ower.CamRoot.Find("Triggers/Capture").gameObject;            captureTrigger = Utils.GetSafeComponent<SimpleTrigger>(captureBtnObj);            captureTrigger.onTrigger = CaptureAPicture;            saveBtnObj = ower.CamRoot.Find("Triggers/Save").gameObject;            saceTrigger = Utils.GetSafeComponent<SimpleTrigger>(saveBtnObj);            saceTrigger.onTrigger = OnSave;            cancelBtnObj = ower.CamRoot.Find("Triggers/Cancel").gameObject;            cancelTrigger = Utils.GetSafeComponent<SimpleTrigger>(cancelBtnObj);            cancelTrigger.onTrigger = OnCancel;            hcAudioSource = Utils.GetSafeComponent<AudioSource>(ower.CamRoot.gameObject);            saveBtnObj.SetActive(false);            cancelBtnObj.SetActive(false);        }        public override void OnUpdate()        {            base.OnUpdate();        }        private void OnCancel()        {            ower.Pian.gameObject.SetActive(false);            saveBtnObj.SetActive(false);            cancelBtnObj.SetActive(false);        }        private void OnSave()        {            string filename = GetFilename();            filename += ".jpg";            byte[] bytes = currentTextureCaptured.EncodeToJPG(100);            FileManagerSecure.CreateDirectory(SHOT_DIRECTORY);            FileManagerSecure.WriteAllBytes(SHOT_DIRECTORY + filename, bytes);            ower.Pian.gameObject.SetActive(false);            saveBtnObj.SetActive(false);            cancelBtnObj.SetActive(false);        }        private void CaptureAPicture()        {            saveBtnObj.SetActive(true);            cancelBtnObj.SetActive(true);            hcAudioSource.Stop();            hcAudioSource.Play();            RenderTexture captureRT = ower.CModule.CaptureRT;            Camera currentActiveCam = ower.CModule.CurrentAtiveCam;            Rect rect = new Rect(0, 0, captureRT.width, captureRT.height);            if (currentTextureCaptured != null) GameObject.Destroy(currentTextureCaptured);            currentTextureCaptured = Utils.CameraCapture(currentActiveCam, rect, captureRT);            ower.Pian.GetComponent<Renderer>().material.mainTexture = currentTextureCaptured;            ower.Pian.localScale = Vector3.zero;            ower.Pian.gameObject.SetActive(true);            iTween.ScaleTo(ower.Pian.gameObject, iTween.Hash("scale", Vector3.one * 0.7f, "time", 2, "islocal", true, "easetype", iTween.EaseType.easeOutBounce));        }        public string GetFilename()        {            return ((int)(DateTime.UtcNow - new DateTime(1970, 1, 1)).TotalSeconds).ToString();        }        public override void UnInit()        {            if (currentTextureCaptured != null) GameObject.Destroy(currentTextureCaptured);        }    }}