/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;using MVR.FileManagementSecure;using System.Linq;using System;using System.Threading;using System.Collections;namespace PluginIdea{    public class VideoRecordModule : HCModuleBase    {        private struct FrameData        {            public byte[] pixels;            public int count;        }        private const string SHOT_DIRECTORY = "Saves/CameraRecord/";        private JSONStorableFloat skipFrameCount;        private JSONStorableFloat sizeDivCount;        private float deltaFrameTime;        private bool isRecord;        private SimpleTrigger recordTrigger;        private Texture2D frameTexture;        private GameObject recordBtnObject;        public VideoRecordModule(HandleCam ower)        {            this.ower = ower;        }        public override void Init()        {            Utils.SetupSpacer(ower, 30, false);            Utils.SetupInfoTextNoScroll(this.ower, "<size=30><b>Record</b></size>", 35, false);            skipFrameCount = Utils.SetupSliderInt(ower, "SkipCount", 3, 2, 10, false);        }        public override void OnReApplyUIParameter()        {                        recordBtnObject = ower.CamRoot.Find("Triggers/Record").gameObject;            recordTrigger = Utils.GetSafeComponent<SimpleTrigger>(recordBtnObject);            recordTrigger.onTrigger = Record;            recordBtnObject.SetActive(false);        }        public override void OnUpdate()        {            base.OnUpdate();            if (Input.GetKeyDown(KeyCode.G))            {                Record();            }        }        private bool isCreateRenderTexture;        private float capturingTime;        private int capturedFrameCount;        private int encodedFrameCount;        private Queue<FrameData> frameQueue;        private bool offlineRender;        private float originalMaximumDeltaTime;        private Thread encodeThread;        private float targetFramerate = 30;        private RenderTexture frameRenderTexture;        private void Record()        {            if (!isRecord)            {                isRecord = true;                ower.CModule.OnCaptureFuncChanged(isRecord);                SuperController.LogMessage("Record");                StartCapture();            }            else            {                isRecord = false;                ower.CModule.OnCaptureFuncChanged(isRecord);                SuperController.LogMessage("stop");                StopThread();            }        }        private void StartCapture()        {            Camera captureCamera = ower.CModule.CurrentAtiveCam;            frameRenderTexture = ower.CModule.CaptureRT;            frameTexture = new Texture2D(frameRenderTexture.width, frameRenderTexture.height, TextureFormat.RGB24, false);            frameTexture.hideFlags = HideFlags.HideAndDontSave;            frameTexture.wrapMode = TextureWrapMode.Clamp;            frameTexture.filterMode = FilterMode.Trilinear;            frameTexture.hideFlags = HideFlags.HideAndDontSave;            frameTexture.anisoLevel = 0;                        capturingTime = 0f;            capturedFrameCount = 0;            encodedFrameCount = 0;            frameQueue = new Queue<FrameData>();                        if (offlineRender)            {                                originalMaximumDeltaTime = Time.maximumDeltaTime;                Time.maximumDeltaTime = Time.fixedDeltaTime;            }            if (encodeThread != null)            {                encodeThread.Abort();            }                        encodeThread = new Thread(FrameEncodeThreadFunction);            encodeThread.Priority = System.Threading.ThreadPriority.Lowest;            encodeThread.IsBackground = true;            encodeThread.Start();        }        private IEnumerator CaptureFrameAsync()        {            yield return new WaitForEndOfFrame();            CopyFrameTexture();            EnqueueFrameTexture();        }        void CopyFrameTexture()        {            RenderTexture.active = frameRenderTexture;            frameTexture.ReadPixels(new Rect(0, 0, frameRenderTexture.width, frameRenderTexture.height), 0, 0, false);            RenderTexture.active = null;        }        private int currentFrameCount = 0;        void EnqueueFrameTexture()        {                                    lock (this)            {                currentFrameCount++;                frameQueue.Enqueue(                    new FrameData(){ pixels = frameTexture.GetRawTextureData(), count = currentFrameCount });            }        }        public override void LateUpdate()        {            base.LateUpdate();            if (isRecord)            {                encodedFrameCount++;                if (encodedFrameCount % (int)skipFrameCount.val == 0)                {                    ower.StartCoroutine(CaptureFrameAsync());                }            }        }        public bool isEncord = true;        private void FrameEncodeThreadFunction()        {            while (frameQueue.Count > 0 || isEncord)            {                if (frameQueue.Count > 0)                {                    FrameData frame;                    lock (this)                    {                        frame = frameQueue.Dequeue();                    }                                        FileManagerSecure.CreateDirectory(SHOT_DIRECTORY);                    FileManagerSecure.WriteAllBytes(SHOT_DIRECTORY + frame.count.ToString(), frame.pixels);                }                else                {                                        Thread.Sleep(50);                }            }            Debug.Log("finished");        }        public override void UnInit()        {            StopThread();            if (frameTexture != null) GameObject.Destroy(frameTexture);        }        private void StopThread()        {            if (encodeThread != null)            {                encodeThread.Abort();            }        }    }}